;***************************************
;THIS PROGRAM FOR TEST GRAPHIC LCD
;240 X 64 DOTS FOR GRAPHIC MODE
;HARDWARE :CP-Z80V3
;SOFTWARE :D32D4CL.EXE
;COMPANY  :ETT CO.,LTD.
;DATE     :25/11/1999
;***************************************
        CPU     "Z80.TBL"
        HOF     "INT8"
;*****************************
        ORG     8000H
        CALL    INIT            ;INITIAL LCD TO CHAR MODE
        CALL    CLR
        LD      HL,0
        CALL    SCA
        LD      HL,STR1
        CALL    WRS
        LD      HL,40
        CALL    SCA
        LD      HL,STR2
        CALL    WRS
        LD      HL,80
        CALL    SCA
        LD      HL,STR3
        CALL    WRS
        LD      HL,120
        CALL    SCA
        LD      HL,STR4
        CALL    WRS
        LD      HL,160
        CALL    SCA
        LD      HL,STR5
        CALL    WRS
AA:     JP      AA
;*******************************
;INITIAL LCD IN CHAR MODE
;*******************************
INIT:   LD      BC,003CH       ;CHAR MODE , CURSOR BLINK
        CALL    WRI
        LD      BC,01A5H       ;Vp = 11, Hp = 6
        CALL    WRI
        LD      BC,0227H       ;40 CHAR / LINE
        CALL    WRI
        LD      BC,033FH       ;SCAN 63 LINE 
        CALL    WRI
        LD      BC,0408H        ;LINE OF CURSOR = 9
        CALL    WRI
        LD      BC,0800H       ;LOWER START ADDRESS =00
        CALL    WRI
        LD      BC,0900H       ;UPPER START ADDRESS =00
        CALL    WRI
        LD      BC,0A00H       ;LOWER POSITION OF CURSOR
        CALL    WRI
        LD      BC,0B00H       ;UPPER POSITION OF CURSOR
        CALL    WRI
        RET
;*******************************
;WRITE  ONE CHAR
;INPUT :D
;*******************************
WOC:    PUSH    BC
        LD      B,0CH
        LD      C,D
        CALL    WRI
        POP     BC
        RET
;*******************************
;READ BUSY FLAG
;*******************************
RDB:    IN      A,(0D3H)
        BIT     7,A
        JR      NZ,RDB
        RET
;*******************************
;CLEAR DISPLAY
;*******************************
CLR:    PUSH    AF
        PUSH    HL
        PUSH    DE
        LD      L,0            ;240  CHAR / LINE
CLR1:   LD      D,20H          ;20H = SPACE
        CALL    WOC
        INC     L
        LD      A,L
        CP      0F0H
        JR      NZ,CLR1
        POP     DE
        POP     HL
        POP     AF
        RET
;******************************
;WRITE STRING
;INPUT :HL
;******************************
WRS:    LD      A,(HL)
        CP      0
        JR      Z,OUT
        LD      D,A
        CALL    WOC
        INC     HL
        JR      WRS
OUT:    RET
;*******************************
;WRITE INSTRUCTION AND DAT
;INPUT : B ==> INST
;      : C ==> DATA
;*******************************
WRI:    PUSH    BC
        CALL    RDB
        LD      A,B             ;INSTRUCTION
        OUT     (0D2H),A
        LD      A,C
        OUT     (0D0H),A        ;DATA
        POP     BC
        RET
;******************************
;SET CURSOR ADDRESS
;INPUT :HL
;******************************
SCA:    LD      C,L            ;
        LD      B,0AH
        CALL    WRI
        LD      C,H
        LD      B,0BH
        CALL    WRI
        RET
;******************************
;DELAY
;******************************
DELAY:  PUSH    BC
        LD      B,0FFH
FF:     LD      A,0FFH
DD:     DEC     A
        JR      NZ,DD
        DJNZ    FF
        POP     BC
        RET
;******************************
STR1:   DFB      "GRAPHIC LCD",0H
STR2:   DFB      "DG-24064",0H
STR3:   DFB      "GRAPHIC AND CHARACTER MODE",0H
STR4:   DFB      "With LED BACKLIGHT",0H
STR5:   DFB      "ETT LTD.,CO.",0H
        END
        
