;***************************************
;THIS PROGRAM FOR TEST GRAPHIC LCD
;240 X 64 DOTS FOR GRAPHIC MODE
;HARDWARE :CP-S8252V1
;SOFTWARE :SXA51.EXE
;COMPANY  :ETT CO.,LTD.
;DATE     :25/11/1999
;***************************************
RS      EQU     P2.0
RW      EQU     P2.1
E       EQU     P2.2
CS      EQU     P2.3
RES     EQU     P2.4
HIAD    EQU     30H
LOAD    EQU     31H
CHR     EQU     32H
BUF     EQU     34H
;*******************************************
        ORG     0000H
        CALL    DEL     ;DELAY POWER ON RESET
        CALL    RESDIS  ;reset dg-24064
AA:     CALL    INITC   ;CHAR MODE
        CALL    HOME    ;set cursor to 0000h
        CALL    CLEAR   ;clear display 
        CALL    HOME    ;set cursor to 0000h
        MOV     A,#'A'H
        CALL    WOC     ;WRITE 'A'
        CALL    DEL3    ;DELAY
G:      CALL    INITG   ;INITIAL GRAPHIC MODE
        CALL    HOME    ;SET CURSOR TO 0000H
        CALL    CPT     ;CLEAR DISPLAY
        MOV     DPTR,#0000
        CALL    SCP
        MOV     R3,#4
EE1:    MOV     A,#0FFH  ;DISPLAY 
        CALL    WOC
        DJNZ    R3,EE1
        CALL    DEL3
        SJMP    AA
;*****************************
;SET CURSOR HOME
;*****************************
HOME:   MOV     DPL,#00
        MOV     DPH,#00
        CALL    SCP
        RET
;******************************
;WRITE INS & DATA
;INPUT :R0,R1
;******************************       
WRB:    CALL    READ
        CLR     E
        CLR     RW
        SETB    RS       ;RS=1
        CLR     CS
        MOV     P1,R0    ;INSTRUCTION
        SETB    E
        CLR     E
        CLR     RW
        CLR     CS        ;RS=0
        CLR     RS
        MOV     P1,R1     ;DATA
        SETB    E
        CLR     E
        RET
;******************************
;INITIAL LCD  IN CHAR MODE
;******************************
INITC:  MOV     R0,#00H
        MOV     R1,#00111100B      ;CHAR MODE,CURSOR BLINK
        CALL    WRB
        MOV     R0,#01H
        MOV     R1,#0A5H           ;VP=11 ,HP=6
        CALL    WRB
        MOV     R0,#2H
        MOV     R1,#39             ;40 CHARACTER/LINE
        CALL    WRB
        MOV     R0,#3H
        MOV     R1,#63             ;SCAN 64 LINE
        CALL    WRB
        MOV     R0,#4H
        MOV     R1,#8H             ;LINE OF CURSOR= 9 
        CALL    WRB
        MOV     R0,#8H
        MOV     R1,#00             ;LOWER ADDRESS OF RAM
        CALL    WRB
        MOV     R0,#9H
        MOV     R1,#00             ;UPPER ADDRESS OF RAM
        CALL    WRB
        RET
;******************************
;INITIAL LCD  IN GRAPHIC MODE
;******************************
INITG:  MOV     R0,#00H
        MOV     R1,#00110010B      ;GRAPHIC MODE
        CALL    WRB
        MOV     R0,#01H
        MOV     R1,#07H            ; 8 BYTES / LINE
        CALL    WRB
        MOV     R0,#2H
        MOV     R1,#29             ;30 BYTE PER  LINE
        CALL    WRB
        MOV     R0,#3H
        MOV     R1,#63             ;SCAN 64 LINE
        CALL    WRB
        MOV     R0,#8H
        MOV     R1,#00             ;LOWER ADDRESS OF RAM
        CALL    WRB
        MOV     R0,#9H
        MOV     R1,#00             ;UPPER ADDRESS OF RAM
        CALL    WRB
        RET
;******************************
;SET CURSOR POSITION
;INPUT  :HIAD:LOAD
;******************************
SCP:    MOV     R0,#0AH
        MOV     A,DPL
        MOV     R1,A
        CALL    WRB
        MOV     R0,#0BH
        MOV     A,DPH
        MOV     R1,A
        CALL    WRB
        RET
;*******************************
;WRITE ONE CHAR OR PATTERN
;INPUT : A
;*******************************
WOC:    MOV     R0,#0CH
        MOV     R1,A
        CALL    WRB
        RET
;*******************************
;READ BUSY
;*******************************
READ:   SETB    RW
        SETB    RS
        CLR     CS
        SETB    E
        MOV     A,P1
        CLR     E
LL:     JB      ACC.7,LL
        RET
;*******************************
;RESET DG24064
;*******************************
RESDIS: SETB    RES
        CLR     RES
        SETB    RES
        RET
;*******************************
;CLEAR CHAR
;*******************************
CLEAR:  MOV     R3,#240
CCL:    MOV     A,#20H
        CALL    WOC
        DJNZ    R3,CCL
        RET
;*******************************
;CLEAR PATTERN
;*******************************
CPT:    MOV     R4,#64
CPT1:   MOV     R3,#30
CPT2:   MOV     A,#0H
        CALL    WOC
        DJNZ    R3,CPT2
        DJNZ    R4,CPT1
        RET
;*******************************
;delay
;*******************************
DEL:    MOV     R7,#00H
AD:     MOV     R6,#00H
        DJNZ    R6,$
        DJNZ    R7,AD
        RET
DEL2:   CALL    DEL
        CALL    DEL
        RET
DEL3:   MOV     R4,#10
DD3:    CALL    DEL2
        DJNZ    R4,DD3
        RET
        END
